---
title: List environments
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Feature Flags
---

# List environments{% #list-environments %}

{% tab title="v2" %}

| Datadog site      | API endpoint                                                        |
| ----------------- | ------------------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v2/feature-flags/environments |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v2/feature-flags/environments |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v2/feature-flags/environments      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v2/feature-flags/environments      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v2/feature-flags/environments  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v2/feature-flags/environments     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v2/feature-flags/environments |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v2/feature-flags/environments |

### Overview

Returns a list of environments for the organization. Supports filtering by name and key. This endpoint requires the `feature_flag_environment_config_read` permission.

### Arguments

#### Query Strings

| Name   | Type    | Description                                     |
| ------ | ------- | ----------------------------------------------- |
| name   | string  | Filter environments by name (partial matching). |
| key    | string  | Filter environments by key (partial matching).  |
| limit  | integer | Maximum number of results to return.            |
| offset | integer | Number of results to skip.                      |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response containing a list of environments.

| Parent field | Field                         | Type      | Description                                                                  |
| ------------ | ----------------------------- | --------- | ---------------------------------------------------------------------------- |
|              | data [*required*]        | [object]  | List of environments.                                                        |
| data         | attributes [*required*]  | object    | Attributes of an environment.                                                |
| attributes   | created_at                    | date-time | The timestamp when the environment was created.                              |
| attributes   | description                   | string    | The description of the environment.                                          |
| attributes   | is_production                 | boolean   | Indicates whether this is a production environment.                          |
| attributes   | key                           | string    | The unique key of the environment.                                           |
| attributes   | name [*required*]        | string    | The name of the environment.                                                 |
| attributes   | queries                       | [string]  | List of queries to define the environment scope.                             |
| attributes   | require_feature_flag_approval | boolean   | Indicates whether feature flag changes require approval in this environment. |
| attributes   | updated_at                    | date-time | The timestamp when the environment was last updated.                         |
| data         | id [*required*]          | uuid      | The unique identifier of the environment.                                    |
| data         | type [*required*]        | enum      | The resource type. Allowed enum values: `environments`                       |
|              | meta                          | object    | Pagination metadata for environments.                                        |
| meta         | page                          | object    | Pagination metadata for environments list responses.                         |
| page         | total_count                   | int64     | Total number of items.                                                       |
| page         | total_filtered_count          | int64     | Total number of items matching the filter.                                   |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": [
    {
      "attributes": {
        "created_at": "2023-01-01T00:00:00Z",
        "description": "Test environment XYZ789",
        "is_production": false,
        "key": "env-search-term",
        "name": "env-search-term",
        "queries": [
          "staging",
          "test"
        ],
        "require_feature_flag_approval": false,
        "updated_at": "2023-01-01T00:00:00Z"
      },
      "id": "550e8400-e29b-41d4-a716-446655440001",
      "type": "environments"
    }
  ],
  "meta": {
    "page": {
      "total_count": 10,
      "total_filtered_count": 5
    }
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Curl command curl -X GET "https://api.datadoghq.com/api/v2/feature-flags/environments" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
##### 

```python
"""
List environments returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.feature_flags_api import FeatureFlagsApi

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = FeatureFlagsApi(api_client)
    response = api_instance.list_feature_flags_environments()

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# List environments returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::FeatureFlagsAPI.new
p api_instance.list_feature_flags_environments()
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// List environments returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewFeatureFlagsApi(apiClient)
	resp, r, err := api.ListFeatureFlagsEnvironments(ctx, *datadogV2.NewListFeatureFlagsEnvironmentsOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `FeatureFlagsApi.ListFeatureFlagsEnvironments`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `FeatureFlagsApi.ListFeatureFlagsEnvironments`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// List environments returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.FeatureFlagsApi;
import com.datadog.api.client.v2.model.ListEnvironmentsResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    FeatureFlagsApi apiInstance = new FeatureFlagsApi(defaultClient);

    try {
      ListEnvironmentsResponse result = apiInstance.listFeatureFlagsEnvironments();
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FeatureFlagsApi#listFeatureFlagsEnvironments");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// List environments returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_feature_flags::FeatureFlagsAPI;
use datadog_api_client::datadogV2::api_feature_flags::ListFeatureFlagsEnvironmentsOptionalParams;

#[tokio::main]
async fn main() {
    let configuration = datadog::Configuration::new();
    let api = FeatureFlagsAPI::with_config(configuration);
    let resp = api
        .list_feature_flags_environments(ListFeatureFlagsEnvironmentsOptionalParams::default())
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * List environments returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.FeatureFlagsApi(configuration);

apiInstance
  .listFeatureFlagsEnvironments()
  .then((data: v2.ListEnvironmentsResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
